;*****WINCALLBACK***************************************************************
WINCB STRUC DWORD      ;main callback local variable space structure
WCB$1          =$
WCB$2          =$
 OEVESI  DWORD  ?      ;old entry value of ESI
 OEVEDI  DWORD  ?      ;old entry value of EDI
 OEVEBP  DWORD  ?      ;old entry value of EBP
 OEVEBX  DWORD  ?      ;old entry value of EBX
 return  DWORD  ?      ;return address
 hwnd    DWORD  ?      ;window handle
 message DWORD  ?      ;message number
 wParam  DWORD  ?      ;wParam
 lParam  DWORD  ?      ;lParam
WINCB ENDS

WCB EQU ESP.WINCB

 .DATA

 SJTNT1 LABEL WORD       ;start of message number table within
                         ;search jump table (SJT)
 SJTabBegin              ;build search/jump table
  SJTabEntry WM_SIZE,SIZE_WM       ;message/address table entry
  SJTabEntry WM_DESTROY,DESTROY_WM ;message/address table entry

 SJTNE1 EQU ($-SJTNT1)/WORD ;number of table entries
 SJTAT1 LABEL WORD       ;start of address table within search jump table (SJT)

 SJTabEnd SJTMIN,\       ;lowest entry value
          SJTMAX,\       ;highest entry value
          @ SIZE_WM      ;address for entry offset

 .CODE
                         ;upon entry, the stack contains the following:
                         ;ESP stack pointer -->return address
                         ;                     window handle
                         ;                     message number
                         ;                     wParam
                         ;                     lParam
WINCALLBACK:
 MOV EAX,[ESP+2*DWORD]   ;window message number from stack

 CMP EAX,SJTMAX          ;SJTMAX=highest window msg num to be user processed
 JA DefWindowProc        ;immediately jump to default handler

 MOV EDX,SJTNE1-1        ;number of entries in window msg number table minus 1
 MOV ECX,@ SJTNT1        ;window message number table address

 .REPEAT                 ;search table for message number
   CMP AX,[ECX+WORD*EDX] ;search last entry first
   JZ @F                 ;breakout if message number found in table
  DEC EDX                ;update counter
 .UNTIL SIGN?            ;exit loop on negative counter value

 JMP DefWindowProc       ;message not found--immediate jump to default handler

@@:                      ;window message number has been found
 RPUSHIT ESI,EDI,EBP,EBX ;save essential windows registers
; SUB ESP,WCB$2-WCB$1     ;make local variable space on stack
 MOVSX ECX,W[SJTAT1+WORD*EDX]
 MOV EBX,[WCB.wParam]    ;EBX=wParam
 MOV ESI,[WCB.hwnd]      ;ESI=windows handle
 ADD ECX,@ SIZE_WM       ;add offset address
 MOV EDX,[WCB.lParam]    ;EDX=lParam
 XOR EBP,EBP             ;EBP=0, valuable to PUSH EBP in handler routines

                         ;after the above instructions, the registers and stack
                         ;contain the following useful values:
                         ;ESI=window handle
                         ;EAX=window message number
                         ;EBX=wParam
                         ;EDX=lParam
                         ;EBP=0
                         ;now, ESP stack pointer -->window callback structure
                         ;                          old entry value of ESI
                         ;                          old entry value of EDI
                         ;                          old entry value of EBP
                         ;                          old entry value of EBX
                         ;                          return addr
                         ;                          windows handle
                         ;                          message number
                         ;                          wParam
                         ;                          lParam

 JMP ECX                 ;jump to message handler routine

MAINCBRET:               ;main callback return--welcome home
; ADD ESP,WCB$2-WCB$1     ;recover main callback local variable space on stack

DIAGBOXRET:              ;dialog box return if needed
 POPIT ESI,EDI,EBP,EBX   ;restore old entry values of essential registers
 RET 4*DWORD             ;balance stack upon returning to windows

;*****END OF MAIN CALLBACK******************************************************
