;*****WINMAIN*******************************************************************
WMSTRUC STRUC
 msg MSG {}      ;message structure ****ALWAYS KEEP MSG STRUCTURE AT BEGINNING
WMSTRUC ENDS

MAIN:
 XOR EBP,EBP     ;handy constant zero
 SUB ESP,WMSTRUC ;make local space

 INVOKE GetModuleHandle,EBP

 MOV ESI,EAX     ;now ESI=module handle
; MOV [hInst],EAX

;*****CLASS REGISTRATION********************************************************
APPNAME EQU 'Scolling Demonstration'
 RPUSHIT EBP,LTEXT(szAppName,APPNAME,0)
 PUSH COLOR_WINDOW+1                      ;for window background color
 INVOKE LoadCursor,EBP,IDC_ARROW
 PUSH EAX                                 ;cursor handle
 INVOKE LoadIcon,EBP,IDI_APPLICATION      ;EBP=0
 S1=CS_HREDRAW OR CS_VREDRAW
 RPUSHIT S1,@ WINCALLBACK,EBP,EBP,ESI,EAX ;ESI=hInst
 INVOKE RegisterClass,ESP

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Class registration failed.',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 ADD ESP,WNDCLASS                        ;balance stack from WNDCLASS
; ADD ESP,WNDCLASSEX                      ;balance stack from WNDCLASSEX

;*****END OF CLASS REGISTRATION*************************************************
;*****WINDOW CREATION***********************************************************

 S1=WS_OVERLAPPEDWINDOW

 INVOKE CreateWindowEx,EBP,@ szAppName,@ szAppName,\
                        S1,CW_USEDEFAULT,CW_USEDEFAULT,\
                        800,400,EBP,EBP,ESI,EBP ;ESI=hInst,EBP=0
IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('Main CreateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

; MOV [hwnd],EAX                       ;window handle
 MOV ESI,EAX                          ;now ESI=hwnd=window handle

;*****END OF WINDOW CREATION****************************************************

 INVOKE ShowWindow,ESI,SW_SHOWNORMAL

 INVOKE UpdateWindow,ESI

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,TEXT('UpdateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 .WHILE NOT 0 ;beginning of message loop
   .WHILE NOT 0 ;beginning of processing loop
     MOV EBX,ESP  ;EBX=ESP=&msg
     INVOKE PeekMessage,EBX,EBP,EBP,EBP,PM_REMOVE ;EBX=&msg
     TEST EAX,EAX

     IF DBUG
      JS PMERR ;jump out on PeekMessage error
     ELSE
      JS EXIT  ;jump out on PeekMessage error
     ENDIF
   .BREAK .IF !ZERO?
     INVOKE Rectangle,[hdcmem],EBP,EBP,[cxClient],[cyClient]  ;erase the back buffer
     MOV EAX,1280       ;determine the point at which to switch right scrolling
     SUB EAX,[cxClient] ;to left scrolling (1280 is the furthest point)

     .IF [scrollpoint] == EAX         ;switch directions back and forth, if necessary
       MOV [direction],1
     .ENDIF
     .IF [scrollpoint] == EBP         ;EBP=0
       MOV [direction],EBP
     .ENDIF
     .IF [direction] == EBP           ;scroll the appropriate direction,EBP=0
       INC scrollpoint
     .ENDIF
     .IF [direction] != EBP           ;EBP=0
       DEC [scrollpoint]
     .ENDIF

     ;Draws the terains from a passed screen coordinate to the end of the screen
     MOV EAX,[scrollpoint]            ;Move the left hand edge of screen into EAX
     XOR EBX,EBX                      ;zero out EBX

     .WHILE [EBX+Terrain.x] <= EAX    ;scroll through the POINT array until we
       ADD EBX,POINT                  ;find the first point to plot
     .ENDW

     .IF EBX                          ;if any other point except the first one, step
       SUB EBX,POINT                  ;back one point (to paint from left-hand edge to
     .ENDIF                           ;first point

     MOV ECX,[EBX+Terrain.x]
     SUB ECX,[scrollpoint]
     INVOKE MoveToEx,[hdcmem],ECX,[EBX+Terrain.y],EBP ;move to the first point
     MOV EAX,[scrollpoint]            ;determine the right hand edge of the screen by adding
     ADD EAX,[cxClient]                 ;the left hand edge plus the size of the screen

     .REPEAT
       MOV ECX,[EBX+Terrain.x]        ;move the landscape point to a temp register
       SUB ECX,[scrollpoint]          ;subtract the offset to position the point in the window
       PUSH EAX                       ;save the right hand edge
       INVOKE LineTo,[hdcmem],ECX,[EBX+Terrain.y] ;draw a line to it
       POP EAX                        ;restore the right hand edge
       ADD EBX,POINT                  ;move to the next point
     .UNTIL [EBX+Terrain.x] > EAX     ;keep doing it until we've draw a whole screens worth

     MOV ECX,[EBX+Terrain.x]          ;move the landscape point to a temp register
     SUB ECX,[scrollpoint]            ;subtract the offset to position the point in the window
     PUSH EAX                         ;save the right hand edge
     INVOKE LineTo,[hdcmem],ECX,[EBX+Terrain.y] ;draw a line to it
     POP EAX                          ;restore the right hand edge
     ADD EBX,POINT                    ;move to the next point

     INVOKE GetDC,ESI                 ;copy back buffer to screen,ESI=hwnd
     PUSH EAX                         ;*****push parameter for ReleaseDC below
     INVOKE BitBlt,EAX,EBP,EBP,[cxClient],[cyClient],[hdcmem],EBP,EBP,SRCCOPY
     INVOKIT ReleaseDC,ESI            ;****parameter pushed above,ESI=hwnd
   .ENDW                              ;repeat processing loop

   .BREAK .IF [ESP.MSG.message] == WM_QUIT ;jump out on WM_QUIT message

   INVOKE TranslateMessage,ESP        ;ESP=&msg
   INVOKE DispatchMessage,ESP         ;ESP=&msg
 .ENDW                                ;repeat message loop

 MOV EAX,[ESP.MSG.wParam]

EXIT:
 ADD ESP,WMSTRUC                      ;recover local space

 INVOKE ExitProcess,EAX

IF DBUG
PMERR:                              ;display error message via message box & jmp to EXIT
 INVOKE MessageBox,ESI,TEXT('GetMessage call error',0),EBP,EBP ;EBP=0
 JMP EXIT
ENDIF

;*****END OF WINMAIN************************************************************
